(document:surround "/std/base")
(document:insert "/std/functions")

(document:envelop with-translation _ "alterator-net-pptp")

;;;;;;;;;;;;;;;;;;;;;;

(gridbox columns "10;50;50;10"
         ;;
	 (spacer)
	 (label (_ "Connection") align "right")
         (hbox (document:id connections (combobox))
               (document:id name (edit "" invisible widget-name "name")))
	 (spacer)


	 ;;
	 (spacer)
         (hbox (document:id start-button (button (_ "Start")))
	       (document:id stop-button (button (_ "Stop")))
	       (document:id del-button (button (_ "Delete"))))
         (document:id new-button (button (_ "Create new")))
	 (spacer)


         ;;
         (spacer)
         (separator)
         (separator)
         (spacer)


	 ;;
	 (spacer)
         (document:id info (label ""))
	 (spacer)
	 (spacer)


         ;;
         (spacer)
         (label (bold (_ "Server")) align "right")
         (document:id server (edit "" widget-name "server"))
         (spacer)
         ;;
         (spacer)
         (label (bold (_ "Login")) align "right")
         (document:id login (edit "" widget-name "login"))
         (spacer)
         ;;
         (spacer)
         (label (bold (_ "Password")) align "right")
         (document:id password (edit "" echo stars widget-name "password"))
         (spacer)
         ;;
         (spacer)
         (label (bold (_ "Walk through interface")) align "right")
         (document:id iface (combobox widget-name "iface"))
         (spacer)
         ;;
	 (spacer)
         (label (_ "Default route via VPN"))
	 (document:id def-via-vpn (checkbox "" widget-name "def-via-vpn"))
         (spacer)
         ;;
	 (spacer)
         (label (_ "Save route to VPN gateway"))
	 (document:id save-route (checkbox "" widget-name "save-route"))
         (spacer)
         ;;
         (spacer)
         (label (_ "MPPE encryption") align "right")
         (document:id mppe (checkbox "" widget-name "mppe"))
	 (spacer)
         ;;
         (spacer)
         (label (_ "Redial on hangup") align "right")
         (document:id persist (checkbox "" widget-name "persist"))
	 (spacer)
         ;;
         (spacer)
         (label (_ "Start at boot") align "right")
         (document:id onboot (checkbox "" widget-name "onboot"))
	 (spacer))

(hbox
 align "center"
 (document:id apply-button (button (_ "Apply")))
 (document:id reset-button (button (_ "Reset")))
 (document:id quit-button (button (_ "Quit") )))


;;;;;;;;;;;;;;;;;;;;;;
(define (go-new)
  (cell-set! new-mode #t)
  (name visibility #t)
  (connections invisible)
;  (format #t "go-new: editables-active~%")
  (editables-active #t)
  (update-constraints "new" "/net-pptp"))

(define (go-edit)
  (cell-set! new-mode #f)
  (name invisible)
  (connections visibility #t)
;  (format #t "go-edit: editables-active~%")
  (editables-active #t)
  (update-constraints "write" "/net-pptp"))

;;;;;;;;;;;;;;;;;;;;;;
(define gates (woo-list-names "/net-pptp/pppX/avail_ifaces"))
(define new-mode (make-cell #f))

(define (editables-active act)
;  (format #t "editables-active: ~S~%" act)
  ((widgets connections server login password iface
	    def-via-vpn save-route mppe persist onboot
	    start-button stop-button del-button apply-button reset-button)
   activity act))

(define (update-connection name)
  (let ((data (woo-read-first (string-append "/net-pptp/" name))))
    (info text (string-append "<small>(" (woo-get-option data 'info) ")</small>" ))
    (server text (woo-get-option data 'server))
    (def-via-vpn state (woo-get-option data 'def_via_vpn))
    (save-route state (woo-get-option data 'save_route))
    (persist state (woo-get-option data 'persist))
    (onboot state (woo-get-option data 'onboot))
    (mppe state (woo-get-option data 'mppe))
    (login text (woo-get-option data 'login))
    (password text "")
    (iface current (or (string-list-index (woo-get-option data 'iface) gates) 0))))

(define (call-update-connection)
  (format #t "call-update-connection~%")
;  (format #t "call-update-connection: editables-active~%")
  (editables-active (> (connections count) 0))
  (and (> (connections count) 0)
       (connections current 0 selected)))

; tell backend to modify existing connection
(define (write-connection name)
  (woo-catch/message
   (thunk
    (let ((pwd (password text)))
      (apply woo-write/constraints (string-append "/net-pptp/" name)
             'server (server text)
	     'def_via_vpn (def-via-vpn state)
	     'save_route (save-route state)
	     'persist (persist state)
	     'onboot (onboot state)
             'mppe (mppe state)
             'iface (iface text)
             'login (login text)
             (if (not-empty-string? pwd) (list 'password pwd) '()))))))

; tell backend to create new connection
(define (new-connection name)
  (and
   (woo-catch/message
    (thunk
     (woo-new/constraints "/net-pptp/"
              'name name
              'server (server text)
	      'def_via_vpn (def-via-vpn state)
	      'save_route (save-route state)
	      'persist (persist state)
	      'onboot (onboot state)
              'mppe (mppe state)
              'iface (iface text)
              'login (login text)
              'password (password text))
     (connections append-row name
                  current (connections count))
     #t))
   (go-edit)))

(define (delete-connection name)
  (woo-delete (string-append "/net-pptp/" name))
  ;(format #t "delete-connections=~S,~S~%" (connections current) (connections text))
  (connections remove (connections current))
  ;(format #t "delete-connections=~S,~S~%" (connections current) (connections text))
  )

(define (get-number x)
  (string->number (substring x 3 (string-length x))))

(define (first-available)
  (cond-plistq
   'name
   (process-defaults (read-constraints "new" "/net-pptp" '()) '())
   ""))

(define (clear-connection)
  ;;clear fields
  ((widgets name server login password info)
   text "")
  (def-via-vpn state #t)
  (save-route state #t)
  (persist state #f)
  (onboot state #f)
  (mppe state #f)
  (iface current 0)
  (name text (first-available)))

; 'what is "start"/"stop"; 'action is already taken :)
(define (do-connection what name)
  ;(format #t "do-connection: what: ~S, name: ~S~%" what name)
  (woo-write (string-append "/net-pptp/" name)
	     'name name
	     'what what
	     'iface (iface text))
  (update-connection name))

;;;;;;;;;;;;;;;;;;;;;;;
(connections (when selected
               (update-connection (connections text))))

; http://wiki.sisyphus.ru/admin/etcnet#vpn
(def-via-vpn (when toggled
	       (if (def-via-vpn state)
		 (save-route state #t))))

(apply-button (when clicked
                (info text (_ "<small>(connecting...)</small>"))
                (if (cell-ref new-mode)
                    (new-connection (name text))
                    (write-connection (connections text)))
		(update-connection (connections text))))

(quit-button (when clicked
               (document:end)))

(reset-button (when clicked
                (if (cell-ref new-mode)
                    (clear-connection)
                    (and (>= (connections current) 0)
                         (connections selected)))))

(start-button (when clicked
		(if (cell-ref new-mode)
		  (apply-button clicked)
		  (do-connection "start" (connections text)))))

(stop-button (when clicked
	       (do-connection "stop" (connections text))))

(new-button (when clicked
              (go-new)
              (clear-connection)
	      (editables-active #t)))

(del-button (when clicked
              (if (cell-ref new-mode)
                  (go-edit)
                  (delete-connection (connections text)))
              (clear-connection)
              (call-update-connection)))

;;;;;;;;;;;;;;;;;;;;;;;
(iface rows gates current 0)
(connections rows (woo-list-names "/net-pptp"))
(call-update-connection)

(document:root
 (when loaded
   (update-constraints "write" "/net-pptp")))
